<?php
/**
 * @copyright Copyright 2023 Genius Plugin Co., Ltd. © All Rights Reserved
 * @version 1.0.0
 * @author geniusplugin.com
 */
if (!defined("WHMCS")) {
    die("This file cannot be accessed directly");
}


/**
 * Get hub server parameters.
 * @param array $params common module parameters
 * @return array
 */
function getTowerRs($hash,$domain,$timestamp)
{
    $ch =  curl_init('https://hub.geniusplugin.com/license.php?v=1.0.0&app=wh&action=rs_hub&domain='. $domain.'&apikey=' .$hash . '&timestamp=' . $timestamp);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 5);
    $result = curl_exec($ch);
    curl_close($ch);
    if (!empty($result)) {
        $server = json_decode($result);
        if (is_array($server)) {
            return $server;     
        }
    }
}

/**
 * Function used to encode the user password
 * We encourage you to strengthen the password. GPF can refuse weaker
 * @param [string] $key = your apikey
 * @param [string] $string = user password
 * @return string
 */
function gpfPassEncrypt($apikey, $string)
{

    if (empty($apikey) || empty($string)) return null;
    $ivlen = openssl_cipher_iv_length($cipher = "AES-128-CBC");
    $iv = openssl_random_pseudo_bytes($ivlen);
    $ciphertext_raw = openssl_encrypt($string, $cipher, $apikey, $options = OPENSSL_RAW_DATA, $iv);
    $hmac = hash_hmac('sha256', $ciphertext_raw, $apikey, $as_binary = true);
    $ciphertext = base64_encode($iv . $hmac . $ciphertext_raw);
    return $ciphertext;
}
